<?php

namespace App\Models\Enums;

use App\Models\Project;
use App\Models\Requirement;
use App\Models\Task;

enum FileObjectType: string
{
    case PROJECT = "project";

    case REQUIREMENT="requirement";

    case TASK = "task";

    public function modelBuilder(): \Illuminate\Database\Eloquent\Builder
    {
        return match ($this) {
            self::PROJECT => Project::query(),
            self::TASK => Task::query(),
            self::REQUIREMENT => Requirement::query(),
        };
    }

    public function modelBuilderAllowed(string $id = null): \Illuminate\Database\Eloquent\Builder
    {
        return match ($this) {
            self::PROJECT => Project::query()->allowed($id),
            self::TASK => Task::query()->allowed($id),
            self::REQUIREMENT => Requirement::query(),
        };
    }
}
